<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class DayPartModalidadeService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
  
	public function buscaDayPart($conditions) {
	    $params = array(
	        ":IDORIGEM"  => isset($conditions['CDMODALIDADE']) ? join('_',  $conditions['CDMODALIDADE']) : null,
	        ":TIDORIGEM" => isset($conditions['CDMODALIDADE']) ? null : "T",
	        ":CDFILIAL"  => join('_',  $conditions['CDFILIAL']),
	        ":NRORG"     => $conditions['NRORG'],
	        ":DTINI"     => $conditions['DTPERIODO'][0],
	        ":DTFIN"     => $conditions['DTPERIODO'][1],
	        ":TCDLOJA"   => 'T',
	        ":CDLOJA"    => null
	    );
	    
	    
	    $return = $this->entityManager->getConnection()->fetchAll(self::DAY_PART_MODALIDADE, $params);

	    foreach($return as &$byFilial){
	        $params['CDFILIAL'] = $byFilial['CDFILIAL'];
	        $byFilial['TOTAL'] = $this->entityManager->getConnection()->fetchAssoc(self::SELECT_TOTAL, $params)["TOTAL"];
	        $byFilial['TOTALVND'] = $this->entityManager->getConnection()->fetchAssoc(self::SELECT_TOTAL_VND, $params)["VALOR_TOTAL"];
	        $NUMPERIODO = explode(' ',$byFilial['PERIODO']);
	        $byFilial['TICKETMEDIO'] = $byFilial['VRVENDAS'] / $byFilial['NRCUPONS'];
	        $byFilial['ITENSPORTICKET'] = $byFilial['QTDE'] / $byFilial['NRCUPONS'];
	        $byFilial['ITENSPORCLIENTE'] = $byFilial['QTDE'] / $byFilial['NRPESMESAVENDA'];
	        $byFilial['PCTPERIODO'] = ($byFilial['VRVENDAS'] * 100) / $byFilial['TOTAL'];
	        $byFilial['LABELFILIAL'] = $byFilial['CDFILIAL'].' - '.$byFilial['NMFILIAL'];
           $byFilial['PERIODOLABEL'] =  $NUMPERIODO[1].' - '.$byFilial['HRINI1DAYPART'].' à '.$byFilial['HRFIN1DAYPART'];
	        $byFilial['FATURAMENTO']  = $byFilial['TOTALVND'] + $byFilial['VALOR_VENDIDO'] + $byFilial['VRDESCONTO'];
	    }
	    return $return;
	}
	
	public function buscaDayPartProd($conditions) {
	    $params = array(
	        ":IDORIGEM"  => isset($conditions['CDMODALIDADE']) ? join('_',  $conditions['CDMODALIDADE']) : null,
	        ":TIDORIGEM" => isset($conditions['CDMODALIDADE']) ? null : "T",
	        ":CDFILIAL"  => join('_',  $conditions['CDFILIAL']),
	        ":NRORG"     => $conditions['NRORG'],
	        ":DTINI"     => $conditions['DTPERIODO'][0],
	        ":DTFIN"     => $conditions['DTPERIODO'][1],
	        ":TCDLOJA"   => 'T',
	        ":CDLOJA"    => null,
	        ":CDPRODUTO"      => array_key_exists('CDARVPROD', $conditions) ? join('_', $conditions['CDARVPROD']) : NULL,
	        ":CDPRODINI"     => array_key_exists('CDARVPRODI', $conditions) ? $conditions['CDARVPRODI'] : NULL,
	        ":CDPRODFIM"     => array_key_exists('CDARVPRODF', $conditions) ? $conditions['CDARVPRODF'] : NULL,
	        ":TCDPRODUTO"     => ((array_key_exists('CDARVPRODF', $conditions) && array_key_exists('CDARVPRODI', $conditions)) || array_key_exists('CDARVPROD', $conditions)) ? NULL : 'T'
	    );
	    $return = $this->entityManager->getConnection()->fetchAll(self::DAT_PART_MODALIDADE_PRODUTO, $params);
	    foreach($return as &$byFilial){
	        $params['CDFILIAL'] = $byFilial['CDFILIAL'];
	        $NUMPERIODO = explode(' ',$byFilial['PERIODO']);
	        $totais = $this->entityManager->getConnection()->fetchAssoc(self::SELECT_TOTAL_PROD, $params);
	        $byFilial['TOTALVND'] = $this->entityManager->getConnection()->fetchAssoc(self::SELECT_TOTAL_VND, $params)["VALOR_TOTAL"];
	        $byFilial['QTDETOTAL'] = $totais['QTDETOTAL'];
	        $byFilial['TOTAL'] = $totais['TOTAL'];
	        $byFilial['LABELFILIAL'] = $byFilial['CDFILIAL'].' - '.$byFilial['NMFILIAL'];
	        $byFilial['LABELPRODUTO'] = $byFilial['CDARVPROD'].' - '.$byFilial['NMPRODUTO'];
	        $byFilial['PCTPRODUTO'] = round((($byFilial['QTDE'] * 100) / $byFilial['QTDETOTAL']), 2);
	        $byFilial['PCTPERIODO'] = round((($byFilial['VRVENDAS'] * 100) / $byFilial['TOTAL']), 2);
	        $byFilial['PERIODOLABEL'] =  $NUMPERIODO[1].' - '.$byFilial['HRINI1DAYPART'].' à '.$byFilial['HRFIN1DAYPART'];
	        $byFilial['FATURAMENTO']  = $byFilial['TOTALVND'] + $byFilial['VALOR_VENDIDO'] + $byFilial['VRDESCONTO'];
	    }
	    return $return;
	}
	
	const DAT_PART_MODALIDADE_PRODUTO = "
	 SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS, 'Período 1' AS PERIODO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO, 
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
   FROM 
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F, PRODUTO O
   WHERE 
      (V.IDSITUVENDA = 'O'         ) AND 
      (V.NRSEQVENDA  = I.NRSEQVENDA) AND
      (V.CDFILIAL    = I.CDFILIAL  ) AND
      (V.CDCAIXA     = I.CDCAIXA   ) AND
      (V.CDFILIAL    = P.CDFILIAL  ) AND
      (V.CDFILIAL    = F.CDFILIAL  ) AND
      (I.CDPRODUTO   = O.CDPRODUTO ) AND
      (I.NRORG       = P.NRORG     ) AND
      (I.NRORG       = F.NRORG     ) AND
      (I.NRORG       = O.NRORG     ) AND
      (I.NRORG       = :NRORG     ) AND
      (INSTR(:CDFILIAL, F.CDFILIAL) <> 0) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
      ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM)) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI1DAYPART AND P.HRFIN1DAYPART)
   GROUP BY 
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO
   UNION ALL
   SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS, 'Período 2' AS PERIODO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
   FROM 
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F, PRODUTO O
   WHERE 
      (V.IDSITUVENDA = 'O'         ) AND 
      (V.NRSEQVENDA  = I.NRSEQVENDA) AND
      (V.CDFILIAL    = I.CDFILIAL  ) AND
      (V.CDCAIXA     = I.CDCAIXA   ) AND
      (V.CDFILIAL    = P.CDFILIAL  ) AND
      (V.CDFILIAL    = F.CDFILIAL  ) AND
      (I.CDPRODUTO   = O.CDPRODUTO ) AND
      (I.NRORG       = P.NRORG     ) AND
      (I.NRORG       = F.NRORG     ) AND
      (I.NRORG       = O.NRORG     ) AND
      (I.NRORG       = :NRORG     ) AND
      (INSTR(:CDFILIAL, F.CDFILIAL) <> 0) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
      ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM)) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI2DAYPART AND P.HRFIN2DAYPART)
   GROUP BY 
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO
   UNION ALL
   SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS, 'Período 3' AS PERIODO,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
   FROM 
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F, PRODUTO O
   WHERE 
      (V.IDSITUVENDA = 'O'         ) AND 
      (V.NRSEQVENDA  = I.NRSEQVENDA) AND
      (V.CDFILIAL    = I.CDFILIAL  ) AND
      (V.CDCAIXA     = I.CDCAIXA   ) AND
      (V.CDFILIAL    = P.CDFILIAL  ) AND
      (V.CDFILIAL    = F.CDFILIAL  ) AND
      (I.CDPRODUTO   = O.CDPRODUTO ) AND
      (I.NRORG       = P.NRORG     ) AND
      (I.NRORG       = F.NRORG     ) AND
      (I.NRORG       = O.NRORG     ) AND
      (I.NRORG       = :NRORG     ) AND
      (INSTR(:CDFILIAL, F.CDFILIAL) <> 0) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
      ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM)) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI3DAYPART AND P.HRFIN3DAYPART)
   GROUP BY 
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO
   UNION ALL
   SELECT 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, SUM(A.QTDE) AS QTDE, 
      A.IDORIGEMVENDA, A.CDARVPROD, A.NMPRODUTO, SUM(A.VRVENDAS) AS VRVENDAS, 'Período 4' AS PERIODO,
      SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO, 
      SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO,
      CASE SUBSTR(A.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
   FROM
      (SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
          SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
       FROM 
          VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F, PRODUTO O
       WHERE 
          (V.IDSITUVENDA = 'O'         ) AND 
          (V.NRSEQVENDA  = I.NRSEQVENDA) AND
          (V.CDFILIAL    = I.CDFILIAL  ) AND
          (V.CDCAIXA     = I.CDCAIXA   ) AND
          (V.CDFILIAL    = P.CDFILIAL  ) AND
          (V.CDFILIAL    = F.CDFILIAL  ) AND
          (I.CDPRODUTO   = O.CDPRODUTO ) AND
          (I.NRORG       = P.NRORG     ) AND
          (I.NRORG       = F.NRORG     ) AND
          (I.NRORG       = O.NRORG     ) AND
          (I.NRORG       = :NRORG     ) AND
          (INSTR(:CDFILIAL, F.CDFILIAL) <> 0) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
          ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM)) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI4DAYPART AND '23:59:59')
       GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO
       UNION ALL
       SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO, 
          SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
       FROM 
          VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F, PRODUTO O
       WHERE 
          (V.IDSITUVENDA = 'O'         ) AND 
          (V.NRSEQVENDA  = I.NRSEQVENDA) AND
          (V.CDFILIAL    = I.CDFILIAL  ) AND
          (V.CDCAIXA     = I.CDCAIXA   ) AND
          (V.CDFILIAL    = P.CDFILIAL  ) AND
          (V.CDFILIAL    = F.CDFILIAL  ) AND
          (I.CDPRODUTO   = O.CDPRODUTO ) AND
          (I.NRORG       = P.NRORG     ) AND
          (I.NRORG       = F.NRORG     ) AND
          (I.NRORG       = O.NRORG     ) AND
          (I.NRORG       = :NRORG     ) AND
          (INSTR(:CDFILIAL, F.CDFILIAL) <> 0) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
          ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM)) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN '00:00:00' AND P.HRFIN4DAYPART)
       GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA, O.CDARVPROD, O.NMPRODUTO) A
   GROUP BY 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, A.IDORIGEMVENDA, A.CDARVPROD, A.NMPRODUTO
   ORDER BY 
      1, 6, 10, 7";
	
	const SELECT_TOTAL_VND = "
		SELECT NVL(SUM(NVL(IT.VRACRITVEND,0))- SUM(NVL(V.VRREPIQUEVENDA,0)), 0) AS VALOR_TOTAL
     FROM ITEMVENDA IT, LOJA L, VENDA V
    WHERE IT.CDPRODUTO   = L.CDPRODTAXAENTR
      AND IT.NRORG = L.NRORG                   AND V.NRSEQVENDA  = IT.NRSEQVENDA
      AND V.CDCAIXA     = IT.CDCAIXA           AND V.CDFILIAL    = IT.CDFILIAL
      AND V.NRORG = IT.NRORG                   AND L.CDLOJA      = V.CDLOJA
      AND L.CDFILIAL    = V.CDFILIAL          AND L.NRORG = V.NRORG
      AND INSTR(:CDFILIAL, V.CDFILIAL) > 0    
      AND L.IDTRATTAXAENTR = 'P'              AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV'    
      AND IT.NRORG = :NRORG                    AND V.IDSITUVENDA = 'O'
      AND ((INSTR(:CDLOJA, L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
      AND INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0
      AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN                       
    GROUP BY V.CDFILIAL, SUBSTR(V.IDORIGEMVENDA, 0, 3)";
	
	const SELECT_TOTAL_PROD = "
   SELECT
      SUM(I.QTPRODVEND) AS QTDETOTAL, 
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS TOTAL
   FROM 
      VENDA V, ITEMVENDA I, PRODUTO O
   WHERE 
      (V.IDSITUVENDA = 'O'         ) AND
      (V.CDFILIAL    = :CDFILIAL   ) AND 
      (V.NRSEQVENDA  = I.NRSEQVENDA) AND 
      (V.CDFILIAL    = I.CDFILIAL  ) AND 
      (V.CDCAIXA     = I.CDCAIXA   ) AND
      (O.CDPRODUTO   = I.CDPRODUTO ) AND
      (I.NRORG       = O.NRORG     ) AND
      (I.NRORG       = :NRORG     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM , SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM  = 'T')) AND
      ((INSTR(:CDPRODUTO, O.CDARVPROD    ) <> 0) OR (:TCDPRODUTO = 'T') OR (O.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))";
	
	const SELECT_TOTAL = "
	SELECT 
   SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS TOTAL
    FROM 
       VENDA V, ITEMVENDA I
    WHERE 
       (V.IDSITUVENDA = 'O'         ) AND
       (V.CDFILIAL    = :CDFILIAL   ) AND 
       (V.NRSEQVENDA  = I.NRSEQVENDA) AND 
       (V.CDFILIAL    = I.CDFILIAL  ) AND 
       (V.CDCAIXA     = I.CDCAIXA   ) AND
       (V.NRORG       = I.NRORG     ) AND
       (V.NRORG       = :NRORG      ) AND
       (V.DTENTRVENDA BETWEEN :DTINI  AND :DTFIN) AND
       ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T'))";
	
	const DAY_PART_MODALIDADE = "
	SELECT
   A.CDFILIAL, A.NMFILIAL, A.HRINI1DAYPART, A.HRFIN1DAYPART, SUM(A.NRPESMESAVENDA) AS NRPESMESAVENDA,
   SUM(A.NRCUPONS) AS NRCUPONS, SUM(A.QTDE) AS QTDE, A.IDORIGEMVENDA, SUM(A.VRVENDAS) AS VRVENDAS, 'Período 1' AS PERIODO,
   SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO, SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO, CASE SUBSTR(A.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
   
FROM
   (SELECT
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, 0 AS NRPESMESAVENDA,
      COUNT(DISTINCT V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) AS NRCUPONS, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO      
   FROM 
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F
   WHERE 
      (V.IDSITUVENDA   = 'O'            ) AND 
      (V.NRSEQVENDA    = I.NRSEQVENDA   ) AND
      (V.CDFILIAL      = I.CDFILIAL     ) AND
      (V.CDCAIXA       = I.CDCAIXA      ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI1DAYPART AND P.HRFIN1DAYPART) AND
      (F.NRORG = I.NRORG) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY 
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, V.IDORIGEMVENDA
   UNION
   SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, SUM(NVL(V.NRPESMESAVENDA,1)) AS NRPESMESAVENDA,
      0 AS NRCUPONS, 0 AS QTDE, V.IDORIGEMVENDA, 0 AS VRVENDAS, 0 AS VALOR_VENDIDO,
      0 AS VRDESCONTO
   FROM 
      VENDA V, PARAVEND P, FILIAL F
   WHERE 
      (V.IDSITUVENDA   = 'O'            ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI1DAYPART AND P.HRFIN1DAYPART) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY 
      V.CDFILIAL, F.NMFILIAL, P.HRINI1DAYPART, P.HRFIN1DAYPART, V.IDORIGEMVENDA) A
GROUP BY
   A.CDFILIAL, A.NMFILIAL, A.HRINI1DAYPART, A.HRFIN1DAYPART, A.IDORIGEMVENDA
UNION ALL
SELECT
   A.CDFILIAL, A.NMFILIAL, A.HRINI2DAYPART, A.HRFIN2DAYPART, SUM(A.NRPESMESAVENDA) AS NRPESMESAVENDA,
   SUM(A.NRCUPONS) AS NRCUPONS, SUM(A.QTDE) AS QTDE, A.IDORIGEMVENDA, SUM(A.VRVENDAS) AS VRVENDAS, 'Período 2' AS PERIODO,
   SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO, 
   SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO, CASE SUBSTR(A.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
FROM
   (SELECT
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, 0 AS NRPESMESAVENDA,
      COUNT(DISTINCT V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) AS NRCUPONS, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO        
   FROM
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F
   WHERE
      (V.IDSITUVENDA   = 'O'            ) AND
      (V.NRSEQVENDA    = I.NRSEQVENDA   ) AND
      (V.CDFILIAL      = I.CDFILIAL     ) AND
      (V.CDCAIXA       = I.CDCAIXA      ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI2DAYPART AND P.HRFIN2DAYPART) AND
      (F.NRORG = I.NRORG) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, V.IDORIGEMVENDA
   UNION
   SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, SUM(NVL(V.NRPESMESAVENDA,1)) AS NRPESMESAVENDA,
      0 AS NRCUPONS, 0 AS QTDE, V.IDORIGEMVENDA, 0 AS VRVENDAS, 0 AS VALOR_VENDIDO,
      0 AS VRDESCONTO
   FROM
      VENDA V, PARAVEND P, FILIAL F
   WHERE
      (V.IDSITUVENDA   = 'O'            ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI2DAYPART AND P.HRFIN2DAYPART) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY
      V.CDFILIAL, F.NMFILIAL, P.HRINI2DAYPART, P.HRFIN2DAYPART, V.IDORIGEMVENDA) A
GROUP BY
   A.CDFILIAL, A.NMFILIAL, A.HRINI2DAYPART, A.HRFIN2DAYPART, A.IDORIGEMVENDA

UNION ALL

SELECT
   A.CDFILIAL, A.NMFILIAL, A.HRINI3DAYPART, A.HRFIN3DAYPART, SUM(A.NRPESMESAVENDA) AS NRPESMESAVENDA,
   SUM(A.NRCUPONS) AS NRCUPONS, SUM(A.QTDE) AS QTDE, A.IDORIGEMVENDA, SUM(A.VRVENDAS) AS VRVENDAS, 'Período 3' AS PERIODO,
   SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO, 
   SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO, CASE SUBSTR(A.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
FROM
   (SELECT
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, 0 AS NRPESMESAVENDA,
      COUNT(DISTINCT V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) AS NRCUPONS, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
      SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO
   FROM
      VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F
   WHERE
      (V.IDSITUVENDA   = 'O'            ) AND
      (V.NRSEQVENDA    = I.NRSEQVENDA   ) AND
      (V.CDFILIAL      = I.CDFILIAL     ) AND
      (V.CDCAIXA       = I.CDCAIXA      ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI3DAYPART AND P.HRFIN3DAYPART) AND
      (F.NRORG = I.NRORG) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, V.IDORIGEMVENDA
   UNION
   SELECT 
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, SUM(NVL(V.NRPESMESAVENDA,1)) AS NRPESMESAVENDA,
      0 AS NRCUPONS, 0 AS QTDE, V.IDORIGEMVENDA, 0 AS VRVENDAS, 0 AS VALOR_VENDIDO,
      0 AS VRDESCONTO
   FROM
      VENDA V, PARAVEND P, FILIAL F
   WHERE
      (V.IDSITUVENDA   = 'O'            ) AND
      (V.CDFILIAL      = P.CDFILIAL     ) AND
      (V.CDFILIAL      = F.CDFILIAL     ) AND
      (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
      ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
      (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
      (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI3DAYPART AND P.HRFIN3DAYPART) AND
      (F.NRORG = P.NRORG) AND
      (F.NRORG = :NRORG)
   GROUP BY
      V.CDFILIAL, F.NMFILIAL, P.HRINI3DAYPART, P.HRFIN3DAYPART, V.IDORIGEMVENDA) A
GROUP BY
   A.CDFILIAL, A.NMFILIAL, A.HRINI3DAYPART, A.HRFIN3DAYPART, A.IDORIGEMVENDA
UNION ALL
SELECT
   A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, SUM(A.NRPESMESAVENDA) AS NRPESMESAVENDA,
   SUM(A.NRCUPONS) AS NRCUPONS, SUM(A.QTDE) AS QTDE, A.IDORIGEMVENDA, SUM(A.VRVENDAS) AS VRVENDAS, 'Período 4' AS PERIODO,
   SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO, 
   SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO, CASE SUBSTR(A.IDORIGEMVENDA, 0, 3) WHEN 'DLV' THEN 'Delivery' WHEN 'BAL' THEN 'Balcão' WHEN 'CMD' THEN 'Comanda'  WHEN 'MES' THEN 'Mesa' WHEN 'IND' THEN 'Indefinido' WHEN 'TAA' THEN 'Terminal de Auto Atendimento' ELSE 'Outros' END AS NMMODALIDADE
FROM
   (SELECT 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, 0 AS NRPESMESAVENDA,
      SUM(A.NRCUPONS) AS NRCUPONS, SUM(A.QTDE) AS QTDE, A.IDORIGEMVENDA, SUM(A.VRVENDAS) AS VRVENDAS,
      A.VALOR_VENDIDO, SUM(TRUNC(NVL(A.VRDESCONTO, 0), 2)) AS VRDESCONTO
   FROM
      (SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART,
          COUNT(DISTINCT V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) AS NRCUPONS, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
          SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO
       FROM 
          VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F
       WHERE 
          (V.IDSITUVENDA   = 'O'            ) AND 
          (V.NRSEQVENDA    = I.NRSEQVENDA   ) AND
          (V.CDFILIAL      = I.CDFILIAL     ) AND
          (V.CDCAIXA       = I.CDCAIXA      ) AND
          (V.CDFILIAL      = P.CDFILIAL     ) AND
          (V.CDFILIAL      = F.CDFILIAL     ) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
          (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI4DAYPART AND '23:59:59') AND
          (F.NRORG = I.NRORG) AND
          (F.NRORG = P.NRORG) AND
          (F.NRORG = :NRORG)
       GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA
       UNION ALL
       SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART,
          COUNT(DISTINCT V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) AS NRCUPONS, SUM(I.QTPRODVEND) AS QTDE, V.IDORIGEMVENDA,
          SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRVENDAS,
           SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0)) AS VALOR_VENDIDO,
           SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO
       FROM 
          VENDA V, ITEMVENDA I, PARAVEND P, FILIAL F
       WHERE 
          (V.IDSITUVENDA   = 'O'            ) AND 
          (V.NRSEQVENDA    = I.NRSEQVENDA   ) AND
          (V.CDFILIAL      = I.CDFILIAL     ) AND
          (V.CDCAIXA       = I.CDCAIXA      ) AND
          (V.CDFILIAL      = P.CDFILIAL     ) AND
          (V.CDFILIAL      = F.CDFILIAL     ) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
          (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN '00:00:00' AND P.HRFIN4DAYPART) AND
          (F.NRORG = I.NRORG) AND
          (F.NRORG = P.NRORG) AND
          (F.NRORG = :NRORG)
       GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA) A
   GROUP BY 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, A.IDORIGEMVENDA, A.VALOR_VENDIDO
   UNION
   SELECT 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, SUM(A.NRPESMESAVENDA) AS NRPESMESAVENDA,
      0 AS NRCUPONS, 0 AS QTDE, A.IDORIGEMVENDA, 0 AS VRVENDAS, 0 AS VALOR_VENDIDO,
      0 AS VRDESCONTO
   FROM
      (SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA,
          SUM(NVL(V.NRPESMESAVENDA,1)) AS NRPESMESAVENDA
       FROM
          VENDA V, PARAVEND P, FILIAL F
       WHERE 
          (V.IDSITUVENDA   = 'O'            ) AND
          (V.CDFILIAL      = P.CDFILIAL     ) AND
          (V.CDFILIAL      = F.CDFILIAL     ) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
          (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN P.HRINI4DAYPART AND '23:59:59') AND
          (F.NRORG = P.NRORG) AND
          (F.NRORG = :NRORG)
        GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA
       UNION ALL
       SELECT 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA,
          SUM(NVL(V.NRPESMESAVENDA,1)) AS NRPESMESAVENDA
       FROM 
          VENDA V, PARAVEND P, FILIAL F
       WHERE 
          (V.IDSITUVENDA   = 'O'            ) AND
          (V.CDFILIAL      = P.CDFILIAL     ) AND
          (V.CDFILIAL      = F.CDFILIAL     ) AND
          (V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) AND
          ((INSTR(:IDORIGEM, SUBSTR(V.IDORIGEMVENDA, 0, 3)) <> 0) OR (:TIDORIGEM = 'T')) AND
          (INSTR(:CDFILIAL, F.CDFILIAL     ) <> 0) AND
          (TO_CHAR(V.DTVENDA, 'HH24:MI:SS') BETWEEN '00:00:00' AND P.HRFIN4DAYPART) AND
          (F.NRORG = P.NRORG) AND
          (F.NRORG = :NRORG)
       GROUP BY 
          V.CDFILIAL, F.NMFILIAL, P.HRINI4DAYPART, P.HRFIN4DAYPART, V.IDORIGEMVENDA) A
   GROUP BY 
      A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, A.IDORIGEMVENDA) A
GROUP BY
   A.CDFILIAL, A.NMFILIAL, A.HRINI4DAYPART, A.HRFIN4DAYPART, A.IDORIGEMVENDA
ORDER BY 
   1, 8, 10";
	
}